void calsm(double ****LY, double ***PSX, double ****BI, double ***PSD, double ****INPH, double ****SIG, double *VAR_Omega)
{
	int i, j, k, l, m, n, zc;
	double  **PBD;
	
	PBD=matrix(1, NM2, 1, NZ2);

	for (k=1; k<=2; k++)
		for (zc=1; zc<NC[k]; zc++) {
			for (i=1; i<NM[k]; i++)
				for (j=1; j<NZ[k]; j++)
					PBD[i][j]=BI[k][zc][i][j];

			for (i=1; i<NM[k]; i++) {
				for (j=1; j<i; j++)
					SIG[k][zc][j][i]=SIG[k][zc][i][j]=0.0;
				SIG[k][zc][i][i]=1.0/PSD[k][zc][i];
			}  
			// SIG[1:NM-1][1:NM-1]=Psi_delta^{-1}
			
			for (i=1; i<NZ[k]; i++)
				for (j=1; j<=i; j++) {
					l=i+NM[k]-1;
					m=j+NM[k]-1;
					SIG[k][zc][l][m]=INPH[k][zc][i][j];
					
					for (n=1; n<NM[k]; n++)
						SIG[k][zc][l][m]+=PBD[n][i]*PBD[n][j]/PSD[k][zc][n];
					
					SIG[k][zc][m][l]=SIG[k][zc][l][m];
				}
			// SIG[NM:NK-1][NM:NK-1]=PHI^{-1}+PBD'*Psi_delta^{-1}*PBD

			for (i=1; i<NM[k]; i++)
				for (j=1; j<NZ[k]; j++) {
					m=j+NM[k]-1;
					SIG[k][zc][i][m]=0.0;
					
					for (l=1; l<NM[k]; l++)
						SIG[k][zc][i][m]-=PBD[l][j]/PSD[k][zc][l];
					
					SIG[k][zc][m][i]=SIG[k][zc][i][m];
				}
			// SIG[1:NM-1][NM:NK-1]=-PBD*Psi_delta^{-1}

			for (i=1; i<NK[k]; i++)
				for (j=1; j<=i; j++) {
					for (l=1; l<NY[k]; l++)
						SIG[k][zc][i][j]+=LY[k][zc][l][i]*LY[k][zc][l][j]/PSX[k][zc][l];

					SIG[k][zc][i][j]/=VAR_Omega[k];
					
					SIG[k][zc][j][i]=SIG[k][zc][i][j];
				}
			// SIG=(SIG+LY'*Psi^{-1}*LY)/VAR_Omega

			iv(SIG[k][zc], NK[k]);
		}

	free_matrix(PBD, 1, NM2, 1, NZ2);

	return ;
}
