#include "tgamalp.c"
#include "talp.c"

void newgamalp(double **Gamma, double ***ALPHA, int ***ZID, double ***AZ, double ***AZGam, int flag)
{
	int h, i, j, k, l, m, s, t, u, u1, u2, row, col;
	long random;
	double newalp, rat1, rat2, ratio, sum, temp;
	double *diag, *PP, **Sigma_alp, **Sigma_gam, **AZGam2;
	
	diag=vector(1, NX);
	PP=vector(1, NX);

	Sigma_alp=matrix(1, NC2, 0, NC2);
	Sigma_gam=matrix(1, NX, 1, NX);
	AZGam2=matrix(1, NO, 1, NT);

	for (k=1; k<=2; k++)
		if (NC[k]>2) {
			for (l=1; l<NX; l++) {
				Sigma_gam[l][l]=siggam;
				
				for (m=1; m<l; m++)
					Sigma_gam[m][l]=Sigma_gam[l][m]=0;
			}
			
			for (i=1; i<NO; i++)	
				for (t=2; t<NT; t++) {
					row=ZID[k][i][t];
					col=ZID[k][i][t-1];

					sum=0;
					
					for (h=1; h<row; h++){
						temp=ALPHA[k][h][col];
							
						sum+=exp(temp)/pow(1+exp(temp), 2);
					}

					if (row<NC[k]-1) {
						temp=ALPHA[k][row][col];

						sum+=exp(temp)/pow(1+exp(temp), 2);
					}

					for (j=1; j<NX; j++)
						for (l=1; l<=j; l++)
							Sigma_gam[j][l]+=sum*AZ[i][j][t]*AZ[i][l][t];

				}
			
			for (j=1; j<NX; j++)
				for (l=1; l<=j; l++)
					Sigma_gam[l][j]=Sigma_gam[j][l];
			
			iv(Sigma_gam, NX);
			
			choldc(Sigma_gam, NX-1, diag);
			
			for (l=1; l<NX; l++) {
				Sigma_gam[l][l]=diag[l];
				random=rand();
				diag[l]=gasdev(&random);
			}
			
			for (l=1; l<NX; l++) {
				temp=0;
				
				for (m=1; m<=l; m++)
					temp+=Sigma_gam[l][m]*diag[m];
				
				PP[l]=Gamma[k][l]+VAR_Gam[k]*temp;
			}

			rat1=tgamalp(ALPHA[k], AZGam[k], ZID[k], NC[k]);
			
			for (l=1; l<NX; l++)
				rat1+=0.5*(Gamma[k][l]-PGamma[k][l])*(Gamma[k][l]-PGamma[k][l])*siggam;
			
			for (m=1; m<NO; m++)
				for (t=1; t<NT; t++) {						
					temp=0;
			
					for (l=1; l<NX; l++)
						temp+=AZ[m][l][t]*PP[l];
						
					AZGam2[m][t]=temp;
				}

			rat2=tgamalp(ALPHA[k], AZGam2, ZID[k], NC[k]);
			
			for (l=1; l<NX; l++)
				rat2+=0.5*(PP[l]-PGamma[k][l])*(PP[l]-PGamma[k][l])*siggam;

			ratio=exp(rat1-rat2);
			
			random=rand();
			temp=ran2(&random);
			
			if (temp<=ratio) {
				for (l=1; l<NX; l++)
					Gamma[k][l]=PP[l];
				
				for (m=1; m<NO; m++)
					for (t=1; t<NT; t++)
						AZGam[k][m][t]=AZGam2[m][t];
				
				if (flag)
					Accept_GAM[k]++;
			}
		}
	// update Gamma[k]
	
	for (k=1; k<=2; k++) {
		for (row=1; row<NC[k]; row++) {
			Sigma_alp[row][0]=sigalp2;
			
			for (col=1; col<NC[k]; col++)
				Sigma_alp[row][col]=sigalp;
		}
		
		for (i=1; i<NO; i++) {
			row=ZID[k][i][1];
			
			for (h=1; h<=row; h++)
				Sigma_alp[h][0]+=0.25;
			
			for (t=2; t<NT; t++) {
				row=ZID[k][i][t];
				col=ZID[k][i][t-1];
				
				sum=exp(AZGam[k][i][t])/pow(1+exp(AZGam[k][i][t]), 2);

				for (h=1; h<=row; h++)
					Sigma_alp[h][col]+=sum;
			}
		}
		
		for (row=1; row<NC[k]; row++) {
			if (RefCate[k][row])
				continue;

			random=rand();
			newalp=ALPHA[k][row][0]+VAR_ALP[k][row][0]*gasdev(&random)/sqrt(Sigma_alp[row][0]);
			
			rat1=talp(ALPHA[k], ZID[k], NC[k]);
			
			rat1+=0.5*(ALPHA[k][row][0]-PALPHA[k][row][0])*(ALPHA[k][row][0]-PALPHA[k][row][0])*sigalp2;
			
			sum=ALPHA[k][row][0];
			ALPHA[k][row][0]=newalp;
			
			rat2=talp(ALPHA[k], ZID[k], NC[k]);
			
			rat2+=0.5*(newalp-PALPHA[k][row][0])*(newalp-PALPHA[k][row][0])*sigalp2;
			
			ratio=exp(rat1-rat2);

			random=rand();
			temp=ran2(&random);

			if (temp<=ratio) {
				if (flag)
					Accept_ALP[k][row][0]++;
			}
			else
				ALPHA[k][row][0]=sum;
			// update ALP[k][row][0]
			
			for (col=1; col<NC[k]; col++) {			
				random=rand();
				newalp=ALPHA[k][row][col]+VAR_ALP[k][row][col]*gasdev(&random)/sqrt(Sigma_alp[row][col]);

				rat1=tgamalp(ALPHA[k], AZGam[k], ZID[k], NC[k]);
				
				rat1+=0.5*(ALPHA[k][row][col]-PALPHA[k][row][col])*(ALPHA[k][row][col]-PALPHA[k][row][col])*sigalp;
				
				sum=ALPHA[k][row][col];
				ALPHA[k][row][col]=newalp;
				
				rat2=tgamalp(ALPHA[k], AZGam[k], ZID[k], NC[k]);
				
				rat2+=0.5*(newalp-PALPHA[k][row][col])*(newalp-PALPHA[k][row][col])*sigalp;
				
				ratio=exp(rat1-rat2); 
				
				random=rand();
				temp=ran2(&random);

				if (temp<=ratio) {
					if (flag)
						Accept_ALP[k][row][col]++;
				}
				else
					ALPHA[k][row][col]=sum;
			}
			// update ALP[k][row][col]
		}
	}

	free_vector(diag, 1, NX);
	free_vector(PP, 1, NX);

	free_matrix(Sigma_alp, 1, NC2, 0, NC2);
	free_matrix(Sigma_gam, 1, NX, 1, NX);
	free_matrix(AZGam2, 1, NO, 1, NT);

	return ;
}
