#include "tomega.c"

void newomega(double ****YO, double ****Omega, double ****Eta, double ****XI, int ***ZID, double ****SIG,
double ***MU, double ****LY, double ***PSX, double ****BI, double ***PSD, double ****INPH)
{
	int i, j, k, l, t, zc;
	long random;
	double *diag, *PP, *GOmega, *GYO, rat1, rat2, ratio, temp;

	diag=vector(1, NK2);
	PP=vector(1, NK2);
	GOmega=vector(1, NK2);
	GYO=vector(1, NY2);

	for (k=1; k<=2; k++) {
		for (zc=1; zc<NC[k]; zc++) {
			choldc(SIG[k][zc], NK[k]-1, diag);

			for (j=1; j<NK[k]; j++)
				SIG[k][zc][j][j]=diag[j];
		}

		for (i=1; i<NO; i++)
			for (t=1; t<NT; t++) {
				zc=ZID[k][i][t];

				for (j=1; j<NK[k]; j++) {
					random=rand(); 
					diag[j]=gasdev(&random);    
					PP[j]=GOmega[j]=Omega[k][i][j][t];
					
					for (l=1; l<=j; l++)
						PP[j]+=SIG[k][zc][j][l]*diag[l];
				}
				
				for (j=1; j<NY[k]; j++)
					GYO[j]=YO[k][i][j][t]-MU[k][zc][j];

				rat1=tomega(GOmega, GYO, LY[k][zc], PSX[k][zc], BI[k][zc], PSD[k][zc], INPH[k][zc], k);
				rat2=tomega(PP,     GYO, LY[k][zc], PSX[k][zc], BI[k][zc], PSD[k][zc], INPH[k][zc], k);
				
				ratio=exp(rat1-rat2);
				
				random=rand();
				temp=ran2(&random);
				
				if (temp<=ratio) {
					for (j=1; j<NK[k]; j++)
						Omega[k][i][j][t]=PP[j];

					for (j=1; j<NM[k]; j++)
						Eta[k][i][j][t]=Omega[k][i][j][t];
					
					for (j=1; j<NZ[k]; j++)
						XI[k][i][j][t]=Omega[k][i][j+NM[k]-1][t];				

					Accept_Omega[k]++;
				}	
			}
	}
	
	free_vector(diag, 1, NK2);
	free_vector(PP, 1, NK2);
	free_vector(GOmega, 1, NK2);
	free_vector(GYO, 1, NY2);

	return ;
}
